// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols
#include "CApplication.h"
#include "CCommandBarPopup.h"
#include "CCommandBarButton.h"

#import "mso.tlb" \
	no_namespace, named_guids, raw_interfaces_only, raw_native_types, rename("RGB","RGB2"), rename("DocumentProperties","DocumentProperties2")

static const int ANY_NUMBER = 99;

class CConnect;
typedef IDispEventImpl<ANY_NUMBER, CConnect, &DIID__CommandBarButtonEvents,
					&LIBID_Office, 2, 3> FindMenuItemEventImpl;
// CConnect
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConnect, &CLSID_Connect>,
	public IDispatchImpl<AddInDesignerObjects::_IDTExtensibility2, &AddInDesignerObjects::IID__IDTExtensibility2, &AddInDesignerObjects::LIBID_AddInDesignerObjects, 1, 0>,
	public FindMenuItemEventImpl
{
public:
	CConnect();

	DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
	DECLARE_NOT_AGGREGATABLE(CConnect)

	BEGIN_COM_MAP(CConnect)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(AddInDesignerObjects::IDTExtensibility2)
	END_COM_MAP()

	BEGIN_SINK_MAP(CConnect)
		SINK_ENTRY_EX(ANY_NUMBER, DIID__CommandBarButtonEvents, 0x00000001, OnFindMenuItemClick)
	END_SINK_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease() 
	{
	}

public:
	//IDTExtensibility2 implementation:
	STDMETHOD(OnConnection)(IDispatch * Application, AddInDesignerObjects::ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);
	STDMETHOD(OnDisconnection)(AddInDesignerObjects::ext_DisconnectMode RemoveMode, SAFEARRAY **custom );
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );

	CComPtr<IDispatch> m_pApplication;
	CComPtr<IDispatch> m_pAddInInstance;
private:
	CApplication m_oWordApp;
	CCommandBarPopup m_oWordFindPopup;
	CCommandBarButton m_oWordFindButton;
	void AddMenuItems();
	void RemoveMenuItems();
public:
	void _stdcall OnFindMenuItemClick(LPDISPATCH button, VARIANT_BOOL* cancelDefault);
};

OBJECT_ENTRY_AUTO(__uuidof(Connect), CConnect)
