#include "StdAfx.h"
#include "dotoleerrors.h"

CComVariant vTrue((short)TRUE),
			vFalse((short)FALSE),
			vOpt((long)DISP_E_PARAMNOTFOUND, VT_ERROR);

DotOleErrors::DotOleErrors(void)
{
}

DotOleErrors::~DotOleErrors(void)
{
}

void DotOleErrors::OleErrorMessages( DotOleException *e)
{
	LPVOID lpMsg;
	::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM |
					FORMAT_MESSAGE_IGNORE_INSERTS, NULL, e->m_sc,
					MAKELANGID(LANG_NEUTRAL,
					SUBLANG_DEFAULT), (LPTSTR)&lpMsg, 0, NULL );
	::MessageBox(NULL, (LPCTSTR)lpMsg, "COM Error", MB_OK | MB_SETFOREGROUND );
	::LocalFree( lpMsg );
}

void DotOleErrors::DispatchErrorMessages(DotOleDispatchException *e)
{
	char msg[512];
	sprintf(msg, "Run-time error '%d':\n\n%s",
		e->m_wCode & 0x0000ffff, e->m_strDescription);
	::MessageBox(NULL, msg, "Server Error", MB_OK | MB_SETFOREGROUND );
}

void DotOleErrors::HRErrorMessages(HRESULT hr, char* heading)
{
	LPVOID lpMsgBuf;
	FormatMessage(  FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM |
					FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					hr,
					0,
					(LPTSTR) &lpMsgBuf,
					0,
					NULL );
	MessageBox( NULL, (LPCTSTR)lpMsgBuf, heading,
									MB_OK | MB_ICONINFORMATION );
	LocalFree( lpMsgBuf );
}