// WordFind.cpp : Implementation of CWordFind

#include "stdafx.h"
#include "WordFind.h"
#include "CRange.h"


// CWordFind
CWordFind::CWordFind( CDocument0* poDocument )
{
	m_poDocument = poDocument;
	m_lWordIndex = 1;
	m_oWords = poDocument->get_Words();
	m_lTotalNumberOfWords = m_oWords.get_Count();
}

CWordFind::~CWordFind()
	{
	}

LRESULT CWordFind::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		CAxDialogImpl<CWordFind>::OnInitDialog(uMsg, wParam, lParam, bHandled);
		bHandled = TRUE;
		m_cWord.Attach( GetDlgItem( IDC_WORD ) );
		return 1;  // Let the system set the focus
	}
	
LRESULT CWordFind::OnClickedOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}

LRESULT CWordFind::OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}

LRESULT CWordFind::OnBnClickedFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// TODO: Add your control notification handler code here
	CString text;
	m_cWord.GetWindowText( text );
	while ( m_lWordIndex <= m_lTotalNumberOfWords )
	{
		CRange oRange = m_oWords.Item( m_lWordIndex );
		m_lWordIndex++;
		CString word = oRange.get_Text();
		word.TrimRight();
		if ( text == word )
		{ 
			oRange.Select();
			return 0; 
		}
	}
	::MessageBox( NULL, text + " Not Found", "Not Found", MB_OK|MB_ICONSTOP );
	return 0;
}
