// WordFind.h : Declaration of the CWordFind

#pragma once

#include "resource.h"       // main symbols

#include <atlhost.h>
#include "CDocument0.h"
#include "CWords.h"

// CWordFind

class CWordFind : 
	public CAxDialogImpl<CWordFind>
{
public:
	CWordFind( CDocument0* poDocument );

	~CWordFind();

	enum { IDD = IDD_WORDFIND };

BEGIN_MSG_MAP(CWordFind)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
	COMMAND_HANDLER(IDC_FIND, BN_CLICKED, OnBnClickedFind)
	CHAIN_MSG_MAP(CAxDialogImpl<CWordFind>)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

LRESULT OnClickedOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

LRESULT OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
public:
	LRESULT OnBnClickedFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

private:
	CWindow m_cWord;
	CDocument0* m_poDocument;
	long m_lTotalNumberOfWords;
	long m_lWordIndex;
	CWords m_oWords;
};


